<template>
  <v-container fluid ma-0 pa-2 white>
    <v-row class="mr-5 ml-1 mb-0 pb-0">
      <v-col cols="12" sm="1" md="1">
        <v-text-field
            v-model="team"
            :items="team"
            label="Quản lý team"
            hide-details
          ></v-text-field>
      </v-col>
      <v-col cols="12" sm="2" md="2">
          <v-select
            v-model="valueBoard.id"
            :items="itemsBoard"
            label="Board Name"
            item-text="name"
            item-value="id"
            return-object
            hide-details
            @change="boardChange()"
          ></v-select>
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <v-select
            v-model="valueProject.key"
            :items="itemsProject"
            label="Project Name"
            item-text="name"
            item-value="key"
            multiple
            hide-details
            return-object
          ></v-select>
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <v-menu
          ref="menu"
          v-model="menu"
          :close-on-content-click="false"
          :return-value.sync="date"
          transition="scale-transition"
          offset-y
          hide-details
          min-width="auto"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="date"
              label="Start Date"
              prepend-icon="mdi-calendar"
              readonly
              v-bind="attrs"
              v-on="on"
              hide-details
            ></v-text-field>
          </template>
          <v-date-picker v-model="date" no-title scrollable>
            <v-spacer></v-spacer>
            <v-btn text color="primary" @click="menu = false"> Cancel </v-btn>
            <v-btn text color="primary" @click="$refs.menu.save(date)">
              OK
            </v-btn>
          </v-date-picker>
        </v-menu>
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <v-menu
          ref="menu2"
          v-model="menu2"
          :close-on-content-click="false"
          :return-value.sync="date2"
          transition="scale-transition"
          offset-y
          min-width="auto"
          hide-details
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="date2"
              label="End Date"
              prepend-icon="mdi-calendar"
              readonly
              v-bind="attrs"
              v-on="on"
              hide-details
            ></v-text-field>
          </template>
          <v-date-picker v-model="date2" no-title scrollable>
            <v-spacer></v-spacer>
            <v-btn text color="primary" @click="menu2 = false"> Cancel </v-btn>
            <v-btn text color="primary" @click="$refs.menu2.save(date2)">
              OK
            </v-btn>
          </v-date-picker>
        </v-menu>
      </v-col>
      <v-col cols="12" sm="1" md="1">
        <v-text-field
          v-model="efforJsonList.jiraDev"
          counter="50"
          hint="Jira ticket"
          label="Jira ticket"
          hide-details
        ></v-text-field>
      </v-col>
      <v-col cols="12" sm="1" md="1" class="pt-5 text-right">
        <v-btn color="success" @click="getTickets()" :disabled='btnDisable'> Search</v-btn>
      </v-col>
      <v-col cols="12" sm="1" md="1" class="pt-5 text-left">
        <v-btn color="success" @click="getWorklogByTicket()" :disabled='btnDisable'> Search by  Jira Ticket</v-btn>
      </v-col>
      
    </v-row>
    <!-- member -->
    <v-row>
      <v-col cols="12" sm="12" md="12">
        <v-row>
          
          <v-col cols="6">
            <v-select
              v-model="member.lstEF"
              :items="itemsMember"
              label="Members"
              item-text="displayName"
              item-value="userName"
              multiple
              hide-details
              return-object
            ></v-select>
          </v-col>
          <v-col cols="5">
            <v-text-field
              v-model="newMember"
              hint="New member"
              label="New member"
              hide-details
            ></v-text-field>
            
          </v-col>
          <v-col cols="1" class="pl-1 pr-1">
            <v-btn color="warning" @click="bpGetEffortByProject()">BPrint Point</v-btn>
          </v-col>
        </v-row>
      </v-col>
    </v-row>
    <v-row v-show="false">
      <v-col cols="12" sm="3" md="3">
        <v-text-field
          v-model="efforJsonList.userName"
          counter="100"
          hint="User Name"
          label="User Name (*)"
        ></v-text-field>
      </v-col>
      <v-col cols="12" sm="3" md="3">
        <v-text-field
          v-model="efforJsonList.pwd"
          counter="50"
          type="password"
          hint="Passsword (*)"
          label="Passsword"
        ></v-text-field>
      </v-col>
      
      
    </v-row>

    <v-row>

      <v-col cols="12" sm="8" md="6" class="pt-0">
        <h3 class="bold">PIM ticket List</h3>
      </v-col>
      <v-col cols="12" sm="4" md="6" class="ma-0 pb-0 pt-0">
        <h3 class="bold">Blueprint Effort Working days: {{this.numberWk}} days</h3>
      </v-col>
      <v-col cols="12" md="6" class="pt-0">
        <hot-table ref="hotTableComponent" :settings="hotSettings"> </hot-table>
        <h3>Worklog by Jira Ticket <span style="color:red"> {{this.jiraIdSeleted}}: {{this.jiraIdTotalHour}}h ({{this.jiraIdTotalHourDetail}})</span></h3>
        <hot-table ref="hotTableComponentWorkLog" :settings="hotSettingsLWorkLog"> </hot-table>
      </v-col>
      <v-col cols="12" md="6" class="pt-0">
        <hot-table ref="hotTableBPEffort" :settings="hotSettingsBPEffort"> </hot-table>
      </v-col>
      
    </v-row>
    
    <!-- <v-row>
      <v-col cols="12" sm="10" md="10" class="mb-0 pb-0">
        <h3>Worklog by Jira Ticket <span style="color:red"> {{this.jiraIdSeleted}}: {{this.jiraIdTotalHour}} hour</span></h3>
      </v-col>
      <v-col cols="12" sm="12" md="12">
        </v-col>
    </v-row> -->
    <v-overlay :value="overlay">
      <v-progress-circular
        indeterminate
        size="64"
      ></v-progress-circular>
    </v-overlay>
  </v-container>
</template>
<script>
import axios from "axios";
import moment from "moment";
import momentBiz from 'moment-business-days';
import config from "../../../config/config";
// import VueJsonPretty from "vue-json-pretty";
// import "vue-json-pretty/lib/styles.css";
import cookieClient from "vue-cookie";
import vueJsonEditor from "vue-json-editor";
import { HotTable } from "@handsontable-pro/vue";
import Handsontable from "handsontable";
// import '~handsontable/dist/handsontable.full.css'
import "handsontable-pro/dist/handsontable.full.css";

export default {
  components: {
    // VueJsonPretty,
    HotTable,
    vueJsonEditor,
    // Loading,
  },
  data() {
    let self = this;
    return {
      date: new Date().toISOString().substr(0, 10),
      date2: new Date().toISOString().substr(0, 10),
      numberWk: 0,
      menu: false,
      menu2: false,
      clvKPI: [],
      team: "Smartlink",
      projectsName: "SPKA",
      valueBoard: {},
      itemsBoard: [],
      valueProject:{},
      itemsProject: [],
      isBtnDisable: false,
      ticketJson: [],
      newMember: "",
      jiraLinkRoot:
        "https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?",
      jiraLink: "",
      userName:"",
      pwd: "",
      jiraDev:"",
      member: {
        lstEF:[
          {
            userName: 'doudevnn',
            displayName: 'Nam Ngoc Nguyen',
            cltName: 'Nam Nguyen Ngoc',
          },
          {
            userName: '203737',
            displayName: 'Dung Cao',
            cltName: 'Dung Cao',
          },
          {
            userName: '213943',
            displayName: 'Hien Pham',
            cltName: 'Hien Pham',
          },
          {
            userName: '203728',
            displayName: 'Khanh Van Nguyen',
            cltName: 'Khanh Nguyen'
          },
          {
            userName: '213960',
            displayName: 'Trang Nguyen Thi Thuy',
            cltName: 'Trang Nguyen Thi Thuy'
          },
        ]
      },
      sumLogs: [],
      //startdate=2021-04-01&enddate=2021-04-30&projects=SPKA,
      itemsMember: [
        {
          userName: 'doudevnn',
          displayName: 'Nam Ngoc Nguyen',
          cltName: 'Nam Nguyen Ngoc',
        },
        {
          userName: '203737',
          displayName: 'Dung Cao',
          cltName: 'Dung Cao',
        },
        {
          userName: '213943',
          displayName: 'Hien Pham',
          cltName: 'Hien Pham',
        },
        {
          userName: '203728',
          displayName: 'Khanh Van Nguyen',
          cltName: 'Khanh Nguyen'
        },
        {
          userName: '213960',
          displayName: 'Trang Nguyen Thi Thuy',
          cltName: 'Trang Nguyen Thi Thuy'
        },
        {
          userName: '1',
          displayName: 'Duc Nguyen'
        },
         {
          userName: '2',
          displayName: 'Toan Van Nguyen'
        },
        {
          userName: '3',
          displayName: 'Thuong Minh Huynh'
        },
      ],
      efforJsonList: {
        jiraLink: "",
        userName:"",
        pwd: "",
        jiraDev:"",
        from: this.date,
        to: this.date2,
        // projectsName: "SmartLink [Internal]",
        month: 5,
        week: 10,
        year: 2021,
        NAM: {
          member: "Nam Nguyen Ngoc",
          account: "doudevnn",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        DUNG: {
          member: "Dung Cao",
          account: "203737",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
        KHANH: {
          member: "Khanh Nguyen",
          account: "203728",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
         HIEN: {
          member: "Hien Pham",
          account: "213943",
          jiraLog: [],
          jiraTicketByTimeH: [],
          total: {},
        },
      },
      pimDATA: [],
      hotSettings: {
        copyPaste: true,
        // data: this.pimDATA,
        height: 300,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "id",
            width: 60,
            className: "htCenter",
          },
          {
            data: "key",
            width: 90,
            className: "htCenter",
          },
          {
            data: "fields.created",
            type: 'date',
            dateFormat: 'YYYY-MM-DD',
            correctFormat: true,
            sortOrder: 'desc',
            width: 130,
            className: "htCenter",
          },
          // {
          //   data: "assigner",
          //   width: 160,
          // },
          {
            data: "fields.assignee.displayName",
          },
        
          {
            data: "fields.issuetype.name",
          },
          {
            data: "fields.status.name",
            width: 120,
          },
          {
            data: "fields.summary",
          },
          {
            data: "fields.timeestimate",
            width: 90,
             className: "htRight",
          },
          {
            data: "fields.customfield_11805",
            width: 90,
             className: "htCenter",
          },
          {
            data: "fields.customfield_11806",
            width: 90,
            className: "htCenter",
          },
        ],
        colHeaders: [
          "jiraId",
          "CLT Ticket",
          "Received Date",
          "Assignee",
          "Task Type",
          "Status",
          "Short Description",
          "EST Effort",
          "Plan Start",
          "Plan Finish",
          "Status Color"
        ],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [ {
            column: 12,
            sortOrder: 'desc'
          }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        afterChange: () => {},
        afterOnCellMouseDown: function () {
            var cell = this;
            console.log('value', cell.getValue());
            let selected = cell.getSelected();
            
            if(selected != undefined && selected[0][1] == 1){
              let data = cell.getData();
              let jiraTicket = cell.getValue();
              self.routerLink(jiraTicket);
              
            }
            if(selected != undefined && selected[0][1] == 0){
              let data = cell.getData();
              let jiraID = cell.getValue();
              self.getWorklogByTicketByID(cell.getSourceData(), data, jiraID);
            }
        },
        cells: function(row, col) {

          if (col === 3) {
            this.renderer = self.assigneeRender;
          }
          this.renderer = self.clvRender;

          if (col === 1) {
            this.renderer = self.stsSRCRender;
          }
          // if (col === 0 || col === 9 || col === 10 || col === 12) {
          //   this.renderer = self.noPlan;
          // }
          
        },
         

      },
      hotSettingsBPEffort: {
        copyPaste: true,
        // data: this.pimDATA,
        stretchH: "all",
        autoWrapRow: true,
        maxRows: 1000,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "usrNm",
          },
           {
            data: "efrtPntAmt",
            className: "htRight",
          },
          {
            data: "point_est",
            className: "htRight",
          },
          {
            data: "point_needmore",
            className: "htRight",
          },
           {
            data: "fin_knt",
            className: "htRight",
          },
           {
            data: "proc_knt",
            className: "htRight",
          },
           {
            data: "point_day_per",
            className: "htRight",
          },
          
          {
            data: "prj",
            width: 60,
          },
          
        ],
        colHeaders: [
          "Name"
          ,"Point"
          ,"Point EST"
          ,"P Need more"
          ,"FN"
          ,"PR"
          ,"PNT/D"
          ,"PRJ"
        ],
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        afterChange: () => {},
        afterOnCellMouseDown: function () {
            // var cell = this;
            // console.log('value', cell.getValue());
            // let selected = cell.getSelected();
            // if(selected != undefined && selected[0][1] == 15){
            //   let data = cell.getData();
            //   let jiraID = cell.getValue();
            //   self.getWorklogByTicketOfline(cell.getSourceData(), data, jiraID);
            // }
          }
         

      },
      hotSettingsLWorkLog: {
        copyPaste: true,
        // data: this.pimDATA,
        startRows: 1000,
        startCols: 15,
        stretchH: "all",
        autoWrapRow: true,
        height: 200,
        rowHeaders: true,
        colHeaders: true,
        filters: true,
        multiColumnSorting: true,
        columns: [
          {
            data: "displayName",
            width: 160,
          },
          {
            data: "userId",
            width: 90,
          },
          {
            data: "timeSpent",
             width: 90,
          },
          {
            data: "updated",
            width: 90,
          },
          {
            data: "comment",
          }
        ],
        colHeaders: [
          "DisplayName",
          "UserId",
          "TimeSpent",
          "Updated",
          "Comment",
        ],
        multiColumnSorting: {
          sortEmptyCells: true,
          initialConfig: [ {
            column: 12,
            sortOrder: 'desc'
          }]
        },
        contextMenu: true,
        dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
        language: "en-US",
        afterChange: () => {},
        // afterOnCellMouseDown: function () {
          //   var cell = this;
          //   console.log('value', cell.getValue());
          //   let selected = cell.getSelected();
          //   if(selected != undefined && selected[0][1] == 15){
          //     let data = cell.getData();
          //     let jiraID = cell.getValue();
          //     self.getWorklogByTicketOfline(data, jiraID);
          //   }
          // }
         

      },
      overlay: false,
      rowWorkLogs: [],
      jiraIdSeleted: "",
      jiraIdTotalHour: 0,
      jiraIdTotalHourDetail: "",
    };
    
  },
  created() {
    // this.getWorklogs();
    // this.jiraBoards();
     momentBiz.updateLocale('us', {
      holidays: config.holidays,
      holidayFormat: 'YYYY-MM-DD'
    });
    moment.updateLocale('us', {
      holidays: config.holidays.map(i => i.holidayDate),
      holidayFormat: 'YYYY-MM-DD'
    });
    this.itemsBoard = JSON.parse(this.$cookies.get('boardList'));
    this.efforJsonList.userName = this.$cookies.get('userName');
    this.efforJsonList.pwd = this.$cookies.get('pwd');

    let start = moment(this.date);
    let end = moment(this.date2);

    console.log("diff", this.generate16InEachMonth());

    //  this.bpGetEffortByProject();
  },
  mounted() {
    // this.getWorklogs();
  },
  watch: {
    date(newVal) {
      // console.log('item changed', newVal);
      this.jiraLink = `https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?startdate=${newVal}&enddate=${this.date2}&projects=${this.projectsName}`;
    },
    date2(newVal) {
      // console.log('item changed', newVal);
      this.jiraLink = `https://pim.cyberlogitec.com/jira/rest/clt-gadget/latest/getWorklogByUser.json?startdate=${this.date}&enddate=${newVal}&projects=${this.projectsName}`;
    },

    btnDisable(){
      // return true
      // if(this.efforJsonList.userName != undefined && this.efforJsonList.userName.trim().length > 0){
      // }
    },
    // overlay (val) {
    //     val && setTimeout(() => {
    //       this.overlay = false
    //     }, 3000)
    //   },
  },
  computed: {
     btnDisable: function () {
       // must parse because Vue turns empty value to string
      if(this.valueBoard.id != undefined 
        && !this.isBtnDisable){
         return false;
      }
      return true;
     },
     boardDisable: function () {
       // must parse because Vue turns empty value to string
      if(!this.isBtnDisable){
         return false;
      }
      return true;
     }
  },
  methods: {
    workday_count(start, end) {
      var first = start.clone().endOf("week"); // end of first week
      var last = end.clone().startOf("week"); // start of last week
      var days = (last.diff(first, "days") * 5) / 7; // this will always multiply of 7
      var wfirst = first.day() - start.day(); // check first week
      if (start.day() == 0) --wfirst; // -1 if start with sunday
      var wlast = end.day() - last.day(); // check last week
      if (end.day() == 6) --wlast; // -1 if end with saturday
      var holidays = this.count_holiday(start, end);
      return wfirst + Math.floor(days) + wlast - holidays; // get the total
    }, //              ^ EDIT: if days count less than 7 so no decimal point

    count_holiday(start, end){
      let count = 0;
      while (start <= end) {
        console.log("start", start.format("YYYY-MM-DD"));
        if(config.holidays.find(({ holidayDate }) => holidayDate == start.format("YYYY-MM-DD"))){
          count++;
        }
        start = start.add(1, "days");
       
      }
      return count;
    },
    generate16InEachMonth() {
      var startDate = moment("2021-09-01").startOf('month');
      var endDate = moment("2021-09-02");
      var eachMonthWith16 = [];
      let monthsList = [];
      // loop by months
      while (endDate >= startDate) {
        monthsList.push(new Date(moment(this.startDate).businessAdd(15, 'days')));
        startDate = startDate.add(1, "month").startOf('month');
      }
      return monthsList;
    },
    onJsonChange(value) {
      var ftest = { date: "2015-02-0", start: 1, end: 7 };
      var ltest = { date: "2015-02-2", start: 2, end: 8 };
      var f = "YYYY-MM-DD";
      var start = moment(ftest.date).add(-1,'days');
      var end = moment(ltest.date).add(1,'days');
      var wd = this.workday_count(start, end);
      console.log("valuewd:", wd);
      // this.efforJsonList.NAM.jiraTicketByTimeH = this.efforJsonList.NAM.jiraLog;
      if (undefined != value) {
        let ticket = null;
        let times = 0;
        this.efforJsonList.NAM.total = {};
        this.efforJsonList.NAM.jiraTicketByTimeH = [];
        for (var i = 0; i < value.issues.length; i++) {
          times += value.issues[i].Worklog / 60 / 60;
          ticket = {
            Issue: value.issues[i].Issue,
            Worklog: value.issues[i].Worklog / 60 / 60,
          };

          this.efforJsonList.NAM.jiraTicketByTimeH.push(ticket);

          //   console.log('valuedd:', this.efforJsonList.NAM.jiraLog.issues[i]);
          //  console.log('index:', i);
        }

        this.efforJsonList.NAM.total.countTicket =
          this.efforJsonList.NAM.jiraTicketByTimeH != undefined
            ? this.efforJsonList.NAM.jiraTicketByTimeH.length
            : 0;
        this.efforJsonList.NAM.total.times = times;
      }
    },

    getEffortJira() {
      this.$cookies.set(
        "crowd.cltems.token_key",
        "lqlZJuuqyynVh4KuuPqGWwAAAAAACYACZG91ZGV2bm4",
        "expiring time"
      );
      this.$cookies.set(
        "JSESSIONID",
        "C0D57CF498029BB85160DB217A0CCA7B",
        "expiring time"
      );
      this.$cookies.set(
        "atlassian.xsrf.token",
        "OX6K_db721eb8bbc90605be85a4afc21424a1def1ec59_lin",
        "expiring time"
      );
      // console.log("CK", this.$cookies.get("NID"));
      axios
        .get(this.jiraLink, {
          headers: {
            cookie:
              "crowd.cltems.token_key=lqlZJuuqyynVh4KuuPqGWwAAAAAACYACZG91ZGV2bm4; JSESSIONID=C0D57CF498029BB85160DB217A0CCA7B; atlassian.xsrf.token=OX6K_db721eb8bbc90605be85a4afc21424a1def1ec59_lin;",
          },
        })
        .then(function (response) {
          console.log("readfolder", response);
        });
    },
    async Insert(member) {
      let seft = this;
      this.efforJsonList.week = parseInt(seft.date.split("-")[1]);
      this.efforJsonList.month = parseInt(seft.date.split("-")[1]);
      this.efforJsonList.year = parseInt(seft.date.split("-")[0]);
      console.log(this.efforJsonList);
      await axios
        .post(config.API_JIRA + "/api/insertKPI", this.efforJsonList)
        .then(function (response) {});
    },
    async reloadBoard(){
      this.jiraBoards();
    },
    async jiraBoards(){
      const seft = this;
      seft.overlay = true;
      await axios
        .post(`${config.API_JIRA}/api/jiraBoards`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('jiraBoards', response.data);
          // seft.pimDATA = response.data.data;
          seft.itemsBoard = response.data.data;
          seft.overlay = false;
        });
    },
    async boardChange(){
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      this.efforJsonList.boardId = seft.valueBoard.id;
      await axios
        .post(`${config.API_JIRA}/api/jiraProjects`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('itemsProject', response.data);
          // seft.pimDATA = response.data.data;
          seft.itemsProject = response.data.data;
          seft.isBtnDisable = false;
          seft.overlay = false;
        });
    },
    async getWorklogs() {
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      seft.$refs.hotTableComponent.hotInstance.loadData([]);
      this.efforJsonList.from =  this.date;
      this.efforJsonList.to = this.date2;
      this.efforJsonList.itemsProject = this.itemsProject;
      this.efforJsonList.team = this.team;
      // this.projectsName = 'SmartLink [Internal]'
      this.efforJsonList.itemsMember = this.member;

      await axios
        .post(`${config.API_JIRA}/api/jiraWorklogs`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          // console.log('pimDATA', seft.pimDATA);
          // seft.pimDATA = response.data.data;
          if(response.data.data != undefined && response.data.data.length > 0){
            await seft.$refs.hotTableComponent.hotInstance.loadData(
              response.data.data
            );
          }else{
            
          }
          seft.isBtnDisable = false;
          seft.overlay = false;

          
          // seft.$refs.hotTableComponent.hotInstance.loadData(seft.pimDATA);
        }).catch((error) => {
            if( error.response ){
                console.log(error.response.data); // => the response payload 
                seft.isBtnDisable = false;
                seft.overlay = false;
            }
        });
    },

    async getTickets() {
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      seft.$refs.hotTableComponent.hotInstance.loadData([]);
      this.efforJsonList.from =  this.date;
      this.efforJsonList.to = this.date2;
      this.efforJsonList.itemsProject = this.itemsProject;
      this.efforJsonList.team = this.team;
      // this.projectsName = 'SmartLink [Internal]'
      this.efforJsonList.itemsMember = this.member;

      await axios
        .post(`${config.API_JIRA}/api/jiraCustomSearch`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          // console.log('pimDATA', seft.pimDATA);
          // seft.pimDATA = response.data.data;
          if(response.data.data != undefined && response.data.data.length > 0){
            let data = response.data.data;
            console.log('pimDATA', data);
            data  = data.filter(function(item){
              item.fields.created = moment(item.fields.created).format("YYYY-MM-DD");
              item.fields.customfield_11806 = moment(item.fields.customfield_11806).format("YYYY-MM-DD");
              item.fields.customfield_11805 = moment(item.fields.customfield_11805).format("YYYY-MM-DD");
              item.fields.timeestimate = item.fields.timeestimate/60/60;
              if(item.fields.assignee != null){
                
                item.fields.assignee.displayName =  seft.splitKoreaName(item.fields.assignee.displayName);
                // return true;
              }else{
                let assignee =  {
                    displayName: "Unassigned",
                };
                item.fields.assignee = assignee;
              }
              return true;
            });
            
            // process data 
            if(data != undefined && data != null){
              // data.array.forEach(item => {
              //   if(item.fields.assignee != null){

              //   }
              // });
              await seft.$refs.hotTableComponent.hotInstance.loadData(
                data
              );

            }
          }else{
            
          }
          seft.isBtnDisable = false;
          seft.overlay = false;

          
          // seft.$refs.hotTableComponent.hotInstance.loadData(seft.pimDATA);
        }).catch((error) => {
            if( error.response ){
                console.log(error.response.data); // => the response payload 
                seft.isBtnDisable = false;
                seft.overlay = false;
            }
        });
    },
    
    async getWorklogByTicket(){
      const seft = this;
      seft.isBtnDisable = true;
      seft.overlay = true;
      this.efforJsonList.boardId = seft.valueBoard.id;
      this.efforJsonList.ticketid = this.efforJsonList.jiraDev;
     
      await axios
        .post(`${config.API_JIRA}/api/getIssueWorklogs`, this.efforJsonList)
        .then(async function (response) {
          // seft.hotSettings.data = response.data.data;
          console.log('itemsProject', response.data);
          // seft.pimDATA = response.data.data;
          seft.isBtnDisable = false;
          seft.ticketJson =  response.data;
          seft.overlay = false;

          console.log("getWorklogByTicket");
          seft.$refs.hotTableComponentWorkLog.hotInstance.loadData([]); 
         
          let logs = response.data.data;
          if(logs != undefined && logs.length > 0){
            let arr = [];
            let total = 0;
            for(var i = 0; i < logs.length; i++){
              arr.push({
                "displayName": logs[i].author.displayName,
                "userId": logs[i].author.name,
                "timeSpent":logs[i].timeSpent,
                "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
                "comment": logs[i].comment,
              });
              total += logs[i].timeSpentSeconds;
            }
            seft.jiraIdTotalHour = total/60/60;
            seft.$refs.hotTableComponentWorkLog.hotInstance.loadData(arr);
            console.log("getWorklogByTicket", logDatas[0].worklogList);
          }
          
        });
    },
    getWorklogByTicketOfline (sources, data, jiraId) {
      console.log("getWorklogByTicketOfline");
      this.$refs.hotTableComponentWorkLog.hotInstance.loadData([]); 
      let logDatas = sources.filter(function(item) { 
        return item.jiraId === jiraId; 
      });
      this.jiraIdSeleted = logDatas[0].key
      let logs = logDatas[0].worklogList;
      if(logs != undefined && logs.length > 0){
        let arr = [];
        let total = 0;
        for(var i = 0; i < logs.length; i++){
          arr.push({
            "displayName": logs[i].author.displayName,
            "userId": logs[i].author.name,
            "timeSpent":logs[i].timeSpent,
            "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
            "comment": logs[i].comment,
          });
          total += logs[i].timeSpentSeconds;
        }
        this.jiraIdTotalHour = total/60/60;
        this.$refs.hotTableComponentWorkLog.hotInstance.loadData(arr);
        console.log("getWorklogByTicketOfline", logDatas[0].worklogList);
      }
    },
    async bpGetEffortByProject(){
      let seft = this;
      // const self
      seft.isBtnDisable = true;
      seft.overlay = true;
      await seft.$refs.hotTableBPEffort.hotInstance.loadData([]); 

      let start = moment(seft.date);
      let end = moment(seft.date2);
      seft.numberWk = this.workday_count(start, end);
      console.log('numberWk',seft.numberWk);
      const diff = moment(start, 'MM-DD-YYYY').businessDiff(moment(end,'MM-DD-YYYY'));
      console.log("diff", diff);

      let lsMember = seft.member.lstEF;
      if((undefined == seft.member.lstEF || seft.member.lstEF.length == 0) && undefined != this.newMember && "" != this.newMember){
        let arrMem = this.newMember.split(",");
        lsMember = [];
        if(arrMem != undefined && arrMem.length > 0){
          for(let i = 0; i < arrMem.length; i++){
            let mem = {
              userName: i + 1,
              displayName: arrMem[i].trim()
            };
            lsMember.push(mem);

          }
        }
        
      }
      let pjtId = "PJT20161221000000003" //EDI
      // let pjtId  = "PJT20140120000000001" //sml
      let paramEDI = {
            pjtId: "PJT20161221000000003"
            ,fromDate:  moment(this.date).format('YYYYMMDD')
            ,toDate:  moment(this.date2).format('YYYYMMDD')
            ,rsName:""
            ,type:"1"
          };
      let paramSML = {
            pjtId: "PJT20140120000000001"
            ,fromDate:  moment(this.date).format('YYYYMMDD')
            ,toDate:  moment(this.date2).format('YYYYMMDD')
            ,rsName:""
            ,type:"1"
          };
      let paramWFlow = {
            pjtId: "PJT20130619000000002"
            ,fromDate:  moment(this.date).format('YYYYMMDD')
            ,toDate:  moment(this.date2).format('YYYYMMDD')
            ,rsName:""
            ,type:"1"
          };

        let paramFWD = {
            pjtId: "PJT20130807000000002"
            ,fromDate:  moment(this.date).format('YYYYMMDD')
            ,toDate:  moment(this.date2).format('YYYYMMDD')
            ,rsName:""
            ,type:"1"
          };

      
      let filterArr3;
      let effortEDI, effortSML, effortWF, effortFWD = [];
      //Get Point EDI
      await axios
        .post(`${config.API_JIRA}/api/blueprintEffort`, paramEDI)
        .then(async function (response) {

          effortEDI = await response.data.data.body.lstUserInPjt;

      });
      
      //Get Point WorkFlow
      await axios
        .post(`${config.API_JIRA}/api/blueprintEffort`, paramWFlow)
        .then(async function (response) {
          effortWF = await response.data.data.body.lstUserInPjt;

      });

      //Get Point FW
      await axios
        .post(`${config.API_JIRA}/api/blueprintEffort`, paramFWD)
        .then(async function (response) {
          effortFWD = await response.data.data.body.lstUserInPjt;

      });
      
      //Get Point SML
      await axios
      .post(`${config.API_JIRA}/api/blueprintEffort`, paramSML)
      .then(async function (response) {
        seft.isBtnDisable = false;
        seft.ticketJson =  response.data;
        seft.overlay = false;
        //Remove duplicate
        effortSML = response.data.data.body.lstUserInPjt;
      });
      
      // await seft.$refs.hotTableBPEffort.hotInstance.loadData([]); 
      // await seft.$refs.hotTableBPEffort.hotInstance.loadData(filterArr3);

      console.log("--------------------- S log data ------------------------");
     
      //Process data
      effortEDI  = await this.bpProcessDuplicateEffortByLstMember(effortEDI, lsMember);
      effortSML = await this.bpProcessDuplicateEffortByLstMember(effortSML, lsMember);
      effortFWD = await this.bpProcessDuplicateEffortByLstMember(effortFWD, lsMember);
      effortWF  = await this.bpProcessDuplicateEffortByLstMember(effortWF, lsMember);

      console.log("effortEDI", effortEDI);
      console.log("effortSML", effortSML);
      console.log("effortFWD", effortFWD);
      console.log("effortWF", effortWF);

      console.log("--------------------- E log data ------------------------");
      console.log("--------------------- E log data ------------------------");

      //Total point
      //Update point total
      self.sumLogs = [];
      for(let obj of effortEDI){
        obj["prj"] = "EDI";
        self.sumLogs.push(obj);
      }
      for(let obj of effortSML){
        obj["prj"] = "SML";
        self.sumLogs.push(obj);
      }
      for(let obj of effortFWD){
        obj["prj"] = "FWD";
        self.sumLogs.push(obj);
      }
      for(let obj of effortWF){
        obj["prj"] = "WF";
        self.sumLogs.push(obj);
      }
      console.log("effortWF", self.sumLogs);
      let dataTable = [];
      let effObj = {};
      for(let i = 0; i < lsMember.length; i++){
        // filterArr3[i].efrtPntAmt = 100000;
        let delayEstm_knt = 0;
        let delay_knt = 0;
        let efrtPntAmt = 0;
        let fin_knt = 0;
        let pd_knt = 0;
        let proc_knt = 0;
        let prj = "";

        for(let j = 0; j < self.sumLogs.length; j++){
          let row = self.sumLogs[j];
          if(row.usrNm == lsMember[i].displayName){
            delayEstm_knt += row.delayEstm_knt;
            delay_knt += row.delay_knt;
            efrtPntAmt += row.efrtPntAmt;
            fin_knt += row.fin_knt;
            pd_knt += row.pd_knt;
            proc_knt += row.proc_knt;
            prj = `${row.prj} ${prj}`;
          }
        }
        effObj = {};
        effObj["usrNm"] = lsMember[i].displayName;
        effObj["delayEstm_knt"] = delayEstm_knt;
        effObj["delay_knt"] = delay_knt;
        effObj["efrtPntAmt"] = efrtPntAmt;
        effObj["fin_knt"] = fin_knt;
        effObj["pd_knt"] = pd_knt;
        effObj["proc_knt"] = proc_knt;

        //per/point
        effObj["point_day"] = Math.round(efrtPntAmt / seft.numberWk); 
        effObj["point_percent"] = Math.round(((efrtPntAmt / seft.numberWk)/200)*100); 
        effObj["point_day_per"] = `${effObj["point_day"]} (${effObj["point_percent"]}%)`;

        effObj["point_est"] = seft.numberWk * 200;
        effObj["point_needmore"] = (seft.numberWk * 200) - efrtPntAmt;
        effObj["prj"] = prj;
        dataTable.push(effObj);
      }
      await seft.$refs.hotTableBPEffort.hotInstance.loadData([]); 
      await seft.$refs.hotTableBPEffort.hotInstance.loadData(dataTable);
      
    },
    /**
     * Get data by mmeber
     */
    async bpProcessDuplicateEffortByLstMember(arrEffort, lsMember){
      if(arrEffort == undefined || arrEffort.length == 0 || lsMember == undefined || lsMember.length == 0){
        return [];
      }
      let seen = new Set();
      //1. Get data 
      arrEffort  = await arrEffort.filter(function(item){
        if(lsMember.find( ({ displayName }) => displayName == item.usrNm)){
          return true;
        }
      });

      //2 Remove duplicate
      arrEffort = await arrEffort.filter(el => {
        const duplicate = seen.has(el.usrNm);
        seen.add(el.usrNm);
        return !duplicate;
      });
      return arrEffort;
    },

    assigneeRender(instance, td, row, col, prop, value, cellProperties) {
      Handsontable.renderers.TextRenderer.apply(this, arguments);
      let newReq = instance.getDataAtCell(row, 3);
      console.log("newReq", cellProperties);
      console.log("prop", prop);
      if(col == 3){
        if(newReq == "Unassigned"){
          td.style.background = '#228B22';
          // td.innerHTML = newReq.displayName;
          // value =  newReq.displayName;
          // prop = "fields.assignee.displayName";
        }
      }
     
    },
    clvRender(instance, td, row, col, prop, value, cellProperties) {
      Handsontable.renderers.TextRenderer.apply(this, arguments);
      let newReq = instance.getDataAtCell(row, 3);
      let rs = this.itemsMember.filter(function(item){
        if(item.cltName == newReq){
          return true;

        }
      });
      if(rs == undefined || rs == null || rs.length == 0){
        td.style.background = '#DEB887';
      }
     
    },
    stsSRCRender(instance, td, row, col, prop, value, cellProperties) {
        Handsontable.renderers.TextRenderer.apply(this, arguments);
         let dataSRC = instance.getDataAtCell(row,9);
          switch(dataSRC){
            case ('Invalid date'):
              td.style.color = 'red';
              // td.className = 'htCenter htMiddle';
              break;
            case 'Request Push':
              td.style.background = 'Orange';
              td.className = 'htCenter htMiddle';
              break;
          }
      },
    routerLink(jiraTicket){
      let route = this.$router.resolve({path: `${config.PIM_URL}/${jiraTicket}`});
      // let route = this.$router.resolve('/link/to/page'); // This also works.
      window.open(`${config.PIM_URL}/${jiraTicket}`, '_blank');
    },
    noPlan(instance, td, row, col, prop, value, cellProperties) {
        Handsontable.renderers.TextRenderer.apply(this, arguments);
        let esteff = instance.getDataAtCell(row,8);
        let start = instance.getDataAtCell(row,9);
        let end = instance.getDataAtCell(row,10);
        if(start == undefined || start == null || start == '' || start == 'Invalid date'
        || end == undefined || end == null || end == '' || end == 'Invalid date'
        || esteff == 0){
          td.style.color = 'red';
          td.className = 'yellow_area';
        }

        //Check overduedate
        if(end != undefined && end !=  null && end !=  '' && end !=  'Invalid date'){
          let isOverDueDate = moment(end).isBefore(moment(new Date()).format("YYYY-MM-DD"));
          let sts = instance.getDataAtCell(row,4);
          let arrValidSts = ["Backlog", "Dev In Progress", "Selected for Development"]
          if (isOverDueDate){
            if(arrValidSts.includes(sts)){
              td.className = 'red';

            }
          }
        }
       
        
      },
    async getWorklogByTicketByID(sources, data, jiraId){
      const seft = this;
      // seft.btnDisable = true;
      seft.overlay = true;
      seft.efforJsonList.boardId = seft.valueBoard.id;
      seft.efforJsonList.ticketid = jiraId;
      await axios
        .post(`${config.API_JIRA}/api/getIssueWorklogs`, seft.efforJsonList)
        .then(async function (response) {
          seft.$refs.hotTableComponentWorkLog.hotInstance.loadData([]); 
          let logs = response.data.data;
          if(logs == undefined || logs == null || logs.length == 0){
            seft.overlay = false;
            return;
          }
          // seft.jiraIdSeleted = logDatas[0].key
          let seen = new Set();
          let arrayDisplay = [];
         
          let arr = [];
          let total = 0;
          for(let i = 0; i < logs.length; i++){
            arr.push({
              "displayName": logs[i].author.displayName,
              "userId": logs[i].author.name,
              "timeSpent":logs[i].timeSpent,
              "updated": moment(logs[i].updated).format("YYYY-MM-DD HH:MM"),
              "comment": logs[i].comment,
            });
            total += logs[i].timeSpentSeconds;
            seen.add(logs[i].author.displayName);
          }

          //Tong tung nguoi
          for(let user of seen){
            let sum = 0;
            console.log("seen[j]", user);
            for(let i = 0; i < logs.length; i++){
              if(logs[i].author.displayName == user){
                sum += logs[i].timeSpentSeconds;
              }
            }
            arrayDisplay.push({
              displayName: user,
              timeSpent: sum/60/60,
            });
          }
          seft.jiraIdTotalHour = total/60/60;
          seft.jiraIdTotalHourDetail = arrayDisplay.map(mem => `${mem.displayName}: ${mem.timeSpent}h`).join(', ');
          
          seft.$refs.hotTableComponentWorkLog.hotInstance.loadData(arr);
        
          seft.overlay = false;
        });
    },

    splitKoreaName(displayName){
      if(displayName != undefined){
        if(displayName.split("(").length > 0 && displayName.split("(")[1] != undefined){
          return (displayName.split("(")[1]).replace(")", "");
          
        }else{
          return displayName;
        }
      }
      return  "";
    }
  },
};

</script>
<style scoped>
  .v-data-table {
    width: 100%;
  }
  .v-top {
    vertical-align: top;
  }
  .v-data-table tr td {
    vertical-align: top;
  }
  .v-data-table tr:hover,
  .v-data-table tbody tr:hover:not(.v-data-table__expanded__content) {
    background: #fff !important;
  }
  .menu__content{
    z-index: 9999 !important;
  }
  .v-overlay--active{
    z-index: 9999 !important;
  }
  #ofBar {
  display: none !important;
}
</style>
